//+------------------------------------------------------------------+
//|                                              JBL-cci.mq4 |
//|                      Copyright  2007, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Blue
//---- input parameters
extern int PeriodBB=20;
extern double PeriodStd=2;
//---- indicator buffers
double UpBuffer[];
double DnBuffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
  int init()
  {
   string short_name;
//---- indicator line
   SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID, 4);
   
   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID, 4);
   
   SetIndexBuffer(0,UpBuffer);
   SetIndexBuffer(1,DnBuffer);
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("JBL-bb");
   SetIndexLabel(0,"UpTrend");
   SetIndexLabel(1,"DownTrend");
//----
   SetIndexDrawBegin(0,PeriodBB);
   SetIndexDrawBegin(1,PeriodBB);
//----
   return(0);
  }

//+------------------------------------------------------------------+
//| RSIFilter_v1                                                         |
//+------------------------------------------------------------------+
int start()
  {
   int shift,trend;
   double BBupper, BBlower;

   
   for(shift=Bars-PeriodBB-1;shift>=0;shift--)
   {	
   BBupper=iBands(NULL,0,PeriodBB,PeriodStd,0,PRICE_CLOSE,MODE_UPPER,shift);
   BBlower=iBands(NULL,0,PeriodBB,PeriodStd,0,PRICE_CLOSE,MODE_LOWER,shift);
   	
	  if (iClose(NULL,0,shift)>BBupper)  trend=1; 
	  if (iClose(NULL,0,shift)<BBlower)  trend=-1;
	  
	  if (trend>0) 
	  {
	  if (iClose(NULL,0,shift)>BBupper) UpBuffer[shift]=1.0;
	  else UpBuffer[shift] = EMPTY_VALUE;
	  DnBuffer[shift]=0;
	  }
	  if (trend<0) 
	  {
	  if (iClose(NULL,0,shift)<BBlower) DnBuffer[shift]=1.0;
	  else DnBuffer[shift] = EMPTY_VALUE;
	  UpBuffer[shift]=0;
	  }
	}
	return(0);	
 }

